PSortedStringList Class Reference

This is a sorted list collection class of `PString` objects. More...

`#include <pstring.h>`

Inheritance diagram for PSortedStringList:

## Public Member Functions

Construction
| PSortedStringList (PINDEX count, char const *const *strarr, PBoolean caseless=false)
| Create a PStringArray from the array of C strings. More...
| PSortedStringList (const PString &str)
| Create a PSortedStringList of length one from the single string. More...
| PSortedStringList (const PStringArray &array)
| Create a PSortedStringList from the array of strings. More...
| PSortedStringList (const PStringList &list)
| Create a PSortedStringList from the list of strings. More...
Overrides from class PObject
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
Operations
PINDEX | AppendString (const PString &str)
| Add a string to the list. More...
PINDEX | GetStringsIndex (const PString &str) const
| Get the index of the string with the specified value. More...
PINDEX | GetNextStringsIndex (const PString &str) const
| Get the index of the next string after specified value. More...
Public Member Functions inherited from PSortedList< T >
| PSortedList ()
| Create a new, empty, sorted list. More...
virtual PObject * | Clone () const
| Make a complete duplicate of the list. More...
T & | operator[] (PINDEX index) const
| Retrieve a reference to the object in the list. More...
Public Member Functions inherited from PAbstractSortedList
| PAbstractSortedList ()
| Create a new, empty, sorted list. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| This method simply returns false as the list order is mantained by the class. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj, PSortedListElement *&lastElement) const
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Protected Member Functions

PINDEX | InternalStringSelect (const char *str, PINDEX len, Element *thisElement, Element *&lastElement) const
Protected Member Functions inherited from PSortedList< T >
| PSortedList (int dummy, const PSortedList *c)
Protected Member Functions inherited from PAbstractSortedList
void | RemoveElement (Element *node)
void | LeftRotate (Element *node)
void | RightRotate (Element *node)
void | DeleteSubTrees (Element *node, PBoolean deleteObject)
PINDEX | ValueSelect (const Element *node, const PObject &obj, const Element **lastElement) const
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Additional Inherited Members

Public Types inherited from PAbstractSortedList
typedef PSortedListElement | Element
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Attributes inherited from PAbstractSortedList
PSortedListInfo * | info
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

This is a sorted list collection class of `PString` objects.

It has all the usual functions for a collection, with the object types set to `PString` pointers.

In addition some addition functions are added that take a const `PString` reference instead of a pointer as most standard collection functions do. This is more convenient for when string expressions are used as parameters to function in the collection.

See the PAbstractSortedList and PSortedList classes for more information.

## Constructor & Destructor Documentation

## PSortedStringList() [1/4]

PSortedStringList::PSortedStringList | ( | PINDEX | count,
|  | char const *const * | strarr,
|  | PBoolean | caseless = `false`
| ) |  |

Create a PStringArray from the array of C strings.

Parameters

  count | Count of strings in array
  strarr | Array of C strings
  caseless | New strings are to be PCaselessStrings

## PSortedStringList() [2/4]

PSortedStringList::PSortedStringList | ( | const PString & | str | ) |

Create a PSortedStringList of length one from the single string.

Parameters

  str | Single string to convert to a list of one.

## PSortedStringList() [3/4]

PSortedStringList::PSortedStringList | ( | const PStringArray & | array | ) |

Create a PSortedStringList from the array of strings.

Parameters

  array | Array of strings to convert to list

## PSortedStringList() [4/4]

PSortedStringList::PSortedStringList | ( | const PStringList & | list | ) |

Create a PSortedStringList from the list of strings.

Parameters

  list | List of strings to convert to list.

## Member Function Documentation

## AppendString()

PINDEX PSortedStringList::AppendString | ( | const PString & | str | ) |

Add a string to the list.

This will place the string in the correct position in the sorted list.

Parameters

  str | String to append.

## GetNextStringsIndex()

PINDEX PSortedStringList::GetNextStringsIndex | ( | const PString & | str | ) | const

Get the index of the next string after specified value.

A binary search of tree is performed to find the string greater than or equal to the specified string value.

Parameters

  str | String value to search for.

## GetStringsIndex()

PINDEX PSortedStringList::GetStringsIndex | ( | const PString & | str | ) | const

Get the index of the string with the specified value.

A binary search of tree is performed to find the string value.

Parameters

  str | String value to search for.

## InternalStringSelect()

PINDEX PSortedStringList::InternalStringSelect | ( | const char * | str,
|  | PINDEX | len,
|  | Element * | thisElement,
|  | Element *& | lastElement
| ) |  | const

protected

## ReadFrom()

virtual void PSortedStringList::ReadFrom | ( | istream & | strm | ) |

virtual

Input the contents of the object from the stream.

This is primarily used by the standard `operator>>` function.

The default behaviour reads '\n' separated strings until `!strm.good()`.

Reimplemented from PObject.

The documentation for this class was generated from the following file:

- pstring.h